function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["days", "dayWidth", "index", "render", "startDate"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { format, differenceInDays, endOfWeek, max, min } from 'date-fns';
import { ACCESSIBLE_DATE_FORMAT, DATE_WEEK_FORMAT, WEEK_START } from './constants';
import { formatPx, isOdd } from './helpers';
import { StyledWeekTitle } from './partials/StyledWeekTitle';
import { StyledWeek } from './partials/StyledWeek';
function renderDefault(_ref) {
  var isOddNumber = _ref.isOddNumber,
    offsetPx = _ref.offsetPx,
    widthPx = _ref.widthPx,
    startDate = _ref.startDate;
  return /*#__PURE__*/React.createElement(StyledWeek, {
    $isOddNumber: isOddNumber,
    $marginLeftPx: offsetPx,
    $widthPx: widthPx
  }, /*#__PURE__*/React.createElement(StyledWeekTitle, null, format(startDate, DATE_WEEK_FORMAT)));
}
function getOffset(startDate, days, dayWidth) {
  var offsetInDays = differenceInDays(startDate, max([startDate, days[0].date]));
  return formatPx(dayWidth, offsetInDays);
}
function getWidth(startDate, days, dayWidth) {
  var lastDateDisplayed = min([endOfWeek(startDate, {
    weekStartsOn: WEEK_START
  }), days[days.length - 1].date]);
  var daysTotal = differenceInDays(lastDateDisplayed, startDate) + 1;
  return {
    daysTotal: daysTotal,
    widthPx: formatPx(dayWidth, daysTotal)
  };
}
export var TimelineWeek = function TimelineWeek(_ref2) {
  var days = _ref2.days,
    dayWidth = _ref2.dayWidth,
    index = _ref2.index,
    render = _ref2.render,
    startDate = _ref2.startDate,
    rest = _objectWithoutProperties(_ref2, _excluded);
  var isOddNumber = isOdd(index);
  var _getWidth = getWidth(startDate, days, dayWidth),
    widthPx = _getWidth.widthPx,
    daysTotal = _getWidth.daysTotal;
  var args = {
    index: index,
    isOddNumber: isOddNumber,
    offsetPx: getOffset(startDate, days, dayWidth),
    widthPx: widthPx,
    dayWidth: dayWidth,
    daysTotal: daysTotal,
    startDate: startDate
  };
  var child = render ? render(args) : renderDefault(args);
  var title = "Week beginning ".concat(format(startDate, ACCESSIBLE_DATE_FORMAT));
  return /*#__PURE__*/React.cloneElement(child, _objectSpread({
    title: title,
    'aria-label': title,
    role: 'columnheader'
  }, rest));
};
TimelineWeek.displayName = 'TimelineWeek';